diff -r a911b4ce0fb5 opus/silk/fixed/burg_modified_FIX.c
--- a/opus/silk/fixed/burg_modified_FIX.c	Fri May 30 13:33:31 2014 +0100
+++ b/opus/silk/fixed/burg_modified_FIX.c	Fri Jun 13 16:59:33 2014 +0100
@@ -46,7 +46,7 @@
     opus_int32                  *res_nrg,           /* O    Residual energy                                             */
     opus_int                    *res_nrg_Q,         /* O    Residual energy Q value                                     */
     opus_int32                  A_Q16[],            /* O    Prediction coefficients (length order)                      */
-    const opus_int16            x[],                /* I    Input signal, length: nb_subfr * ( D + subfr_length )       */
+    const opus_int16            x_Q15[],            /* I    Input signal, length: nb_subfr * ( D + subfr_length )       */
     const opus_int32            minInvGain_Q30,     /* I    Inverse of max prediction gain                              */
     const opus_int              subfr_length,       /* I    Input signal subframe length (incl. D preceding samples)    */
     const opus_int              nb_subfr,           /* I    Number of subframes stacked in x                            */
@@ -64,6 +64,18 @@
     opus_int32       CAb[ SILK_MAX_ORDER_LPC + 1 ];
     opus_int32       xcorr[ SILK_MAX_ORDER_LPC ];
 
+    // MC: This is a workaround to fix the fact that this code misbehaves for high signal levels,
+    // Hence the need for down-scaling.
+    opus_int16 x_Q14[nb_subfr * ( D + subfr_length )];
+    opus_int32 max_absx = 0;
+    for (n = 0; n < nb_subfr * ( D + subfr_length ); n++) {
+        opus_int32 tmp = silk_abs(x_Q15[n]);
+        if (tmp > max_absx) max_absx = tmp;
+        x_Q14[n] = x_Q15[n] >> 1;
+    }
+    const opus_int16 *x = x_Q15;
+    if (max_absx >= 16384) x = x_Q14;
+
     silk_assert( subfr_length * nb_subfr <= MAX_FRAME_SIZE );
 
     /* Compute autocorrelations, added over subframes */
@@ -276,4 +288,5 @@
         *res_nrg = silk_SMLAWW( nrg, silk_SMMUL( SILK_FIX_CONST( FIND_LPC_COND_FAC, 32 ), C0 ), -tmp1 );/* Q( -rshifts ) */
         *res_nrg_Q = -rshifts;
     }
+    if (x == x_Q14) *res_nrg_Q -= 2;
 }
